<template>
  <transition-group name="fade" tag="div" class="row">
    <b-col
      lg="4"
      class="mb-4"
      :key="card.id"
      v-for="card of cards"
    >
      <b-card>
        <b-card-img :src="card.image" @error="handleImgError" />
        <b-card-title v-text="card.name"></b-card-title>
        <b-card-text v-text="card.description"></b-card-text>
        <b-card-title>{{ card.price | currency }}</b-card-title>
        <b-button @click="handleClick(i)" variant="primary">Удалить</b-button>
      </b-card>
    </b-col>
  </transition-group>
</template>
<script>
export default {
  name: "Products",
  props: {
    sort: {
      type: String,
      default: null,
    },
  },
  computed: {
    cards() {
      const cards = this.$store.getters["catalog/getCards"].slice();

      if (this.sort) {
        switch (this.sort) {
          case "asc":
            cards.sort((a, b) => {
              a = a["price"].replace(/\s/g, "");
              b = b["price"].replace(/\s/g, "");

              return parseInt(a) - parseInt(b);
            });
            break;
          case "desc":
            cards.sort((a, b) => {
              a = a["price"].replace(/\s/g, "");
              b = b["price"].replace(/\s/g, "");

              return parseInt(b) - parseInt(a);
            });
            break;
          case "name":
            cards.sort((a, b) => {
              a = a["name"].toLowerCase();
              b = b["name"].toLowerCase();

              if (a < b) {
                return -1;
              } else if (a < b) {
                return 1;
              }

              return 0;
            });
            break;
          default:
            break;
        }
      }

      return cards;
    },
  },
  methods: {
    handleClick(i) {
      return this.$store.commit("catalog/removeCard", i);
    },
    handleImgError($event) {
      $event.target.src = "/placeholder.jpg";
    },
  },
  filters: {
    currency(price) {
      return price + " руб.";
    },
  },
};
</script>
<style scoped>
.fade-enter-active,
.fade-leave-active {
  transition: all 0.7s ease;
}
/* .fade-leave-active {
  position: absolute;
} */

.fade-enter,
.fade-leave-to {
  opacity: 0;
  transform: translateY(30px);
}
.fade-move {
  transition: all 0.7s ease;
}
</style>